Add ticker script

This commit is contained in:
Salt 2021-05-08 17:01:20 -05:00
parent 93844008f3
commit 383eb1a728
1 changed files with 165 additions and 0 deletions

165
tick Executable file
View File

@ -0,0 +1,165 @@
#! /bin/bash
#
# tick
# A program to get the price of a symbol from Binance
# Copyright (C) 2021 Vintage Salt <rehashedsalt@cock.li>
#
# Distributed under terms of the MIT license.
#
set -e
# Read-only set-once variables
declare -r _name="$(basename -- "$0")"
# Options
declare -i _opthelp
declare -i _optverbose
declare -i _optcolor
declare _optsymbol
# Working variables
declare -a _args
declare _return
# Helper functions
log() {
# Print a line to the terminal if _optverbose is greater than $2
# $2 defaults to 0
# loglevel 0: Daily-use messages
# loglevel 1: Detailed but not quite debugging
# loglevel 2: Definitely debugging
[ -z "$1" ] && return 1
if (( _optverbose >= ${2:-0} )); then
printf "%s\\n" "$1"
fi
}
warn() {
# Print a yellow line to the terminal, respecting _optverbose
[ -z "$1" ] && return 1
if (( _optverbose >= ${2:-0} )); then
if [ -t 1 ]; then
printf "\\e[33m%s\\e[0m\\n" "$1"
else
printf "WARN: %s\\n" "$1"
fi
fi
}
error() {
# Print a red line to the terminal, exit if $2 is specified
[ -z "$1" ] && return 1
if [ -t 2 ]; then
printf "\\e[31m%s\\e[0m\\n" "$1" 1>&2
else
printf "ERROR: %s\\n" "$1" 1>&2
fi
[ -z "$2" ] && return
exit "${2:-1}"
}
has() {
# Parse out all arguments and try to find them in path
# If an argument cannot be found, set _return and fail
for prog in "$@"; do
if ! command -v "$prog" > /dev/null 2>&1; then
_return="$prog"
return 1
fi
done
return 0
}
# Core program functions
printhelp() {
cat << EOF
Usage: $_name [OPTION]... SYMBOL
Get the 24hr price change for a particular symbol from Binance
-c Add color to the output
-d SYMBOL Change the symbol displayed. Useful for comparisons against USDC
and other stablecoins
-h Print this help text
-v Print more status messages. Stacks
Copyright (c) 2021 rehashedsalt@cock.li
Licensed under the MIT license
EOF
}
getprice() {
# Get the price of a coin from Binance
[ -z "$1" ] && return 1
symbol="$1"
result="$(curl -sL "https://api.binance.com/api/v3/ticker/24hr?symbol=$symbol")"
# Test to see if we got an error
if echo "$result" | jq '.code' -e > /dev/null 2>&1; then
code="$(echo "$result" | jq -re '.code')"
msg="$(echo "$result" | jq -re '.msg')"
error "Error $code: $msg" 51
fi
# Parse out the data
if [ -n "$_optsymbol" ]; then
symbol="$_optsymbol"
else
symbol="$(echo "$result" | jq -re '.symbol')"
fi
price="$(echo "$result" | jq -re '.priceChangePercent')"
if [ -n "$_optcolor" ]; then
if [[ "$price" == -* ]]; then
price="\e[31m$price\e[0m"
else
price="\e[32m$price\e[0m"
fi
fi
printf "$symbol $price\n"
}
# Main
main() {
# Parse out arguments
while [ -n "$1" ]; do
# Parse out flags
while getopts ":cd:hv" opt; do
case $opt in
c)
_optcolor=1
;;
d)
_optsymbol="$OPTARG"
;;
h)
_opthelp=1
;;
v)
_optverbose+=1
;;
:)
error "Option requires argument: -$OPTARG" 2
;;
*)
error "Invalid option: -$OPTARG" 2
;;
esac
done
# Store arguments
shift $((OPTIND - 1))
if [ -n "$1" ]; then
_args+=("$1")
shift
fi
unset OPTIND
done
# Early hook for help
[ -n "$_opthelp" ] && printhelp && exit 0
# Validate critical options
if [ -z "${_args[*]}" ]; then
error "No symbol specified" 50
fi
# Validate core program dependencies
log "Validating dependencies" 2
if ! has basename curl jq; then
error "Failed to find program: $_return" 1
fi
# Do the do
getprice "${_args[0]}"
exit 0
}
main "$@"